/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

"use strict";var t=require("@lexical/utils"),e=require("lexical");function r(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var n=r((function(t){const e=new URLSearchParams;e.append("code",t);for(let t=1;t<arguments.length;t++)e.append("v",arguments[t]);throw Error(`Minified Lexical error #${t}; visit https://lexical.dev/docs/error?${e} for the full message or use the non-minified dev environment for full errors and additional helpful warnings.`)}));const i=new Set(["http:","https:","mailto:","sms:","tel:"]);class l extends e.ElementNode{static getType(){return"link"}static clone(t){return new l(t.__url,{rel:t.__rel,target:t.__target,title:t.__title},t.__key)}constructor(t="",e={},r){super(r);const{target:n=null,rel:i=null,title:l=null}=e;this.__url=t,this.__target=n,this.__rel=i,this.__title=l}createDOM(e){const r=document.createElement("a");return r.href=this.sanitizeUrl(this.__url),null!==this.__target&&(r.target=this.__target),null!==this.__rel&&(r.rel=this.__rel),null!==this.__title&&(r.title=this.__title),t.addClassNamesToElement(r,e.theme.link),r}updateDOM(e,r,n){if(t.isHTMLAnchorElement(r)){const t=this.__url,n=this.__target,i=this.__rel,l=this.__title;t!==e.__url&&(r.href=t),n!==e.__target&&(n?r.target=n:r.removeAttribute("target")),i!==e.__rel&&(i?r.rel=i:r.removeAttribute("rel")),l!==e.__title&&(l?r.title=l:r.removeAttribute("title"))}return!1}static importDOM(){return{a:t=>({conversion:s,priority:1})}}static importJSON(t){return o().updateFromJSON(t)}updateFromJSON(t){return super.updateFromJSON(t).setURL(t.url).setRel(t.rel||null).setTarget(t.target||null).setTitle(t.title||null)}sanitizeUrl(t){try{const e=new URL(t);if(!i.has(e.protocol))return"about:blank"}catch(e){return t}return t}exportJSON(){return{...super.exportJSON(),rel:this.getRel(),target:this.getTarget(),title:this.getTitle(),url:this.getURL()}}getURL(){return this.getLatest().__url}setURL(t){const e=this.getWritable();return e.__url=t,e}getTarget(){return this.getLatest().__target}setTarget(t){const e=this.getWritable();return e.__target=t,e}getRel(){return this.getLatest().__rel}setRel(t){const e=this.getWritable();return e.__rel=t,e}getTitle(){return this.getLatest().__title}setTitle(t){const e=this.getWritable();return e.__title=t,e}insertNewAfter(t,e=!0){const r=o(this.__url,{rel:this.__rel,target:this.__target,title:this.__title});return this.insertAfter(r,e),r}canInsertTextBefore(){return!1}canInsertTextAfter(){return!1}canBeEmpty(){return!1}isInline(){return!0}extractWithChild(t,r,n){if(!e.$isRangeSelection(r))return!1;const i=r.anchor.getNode(),l=r.focus.getNode();return this.isParentOf(i)&&this.isParentOf(l)&&r.getTextContent().length>0}isEmailURI(){return this.__url.startsWith("mailto:")}isWebSiteURI(){return this.__url.startsWith("https://")||this.__url.startsWith("http://")}}function s(e){let r=null;if(t.isHTMLAnchorElement(e)){const t=e.textContent;(null!==t&&""!==t||e.children.length>0)&&(r=o(e.getAttribute("href")||"",{rel:e.getAttribute("rel"),target:e.getAttribute("target"),title:e.getAttribute("title")}))}return{node:r}}function o(t="",r){return e.$applyNodeReplacement(new l(t,r))}function u(t){return t instanceof l}class a extends l{constructor(t="",e={},r){super(t,e,r),this.__isUnlinked=void 0!==e.isUnlinked&&null!==e.isUnlinked&&e.isUnlinked}static getType(){return"autolink"}static clone(t){return new a(t.__url,{isUnlinked:t.__isUnlinked,rel:t.__rel,target:t.__target,title:t.__title},t.__key)}getIsUnlinked(){return this.__isUnlinked}setIsUnlinked(t){const e=this.getWritable();return e.__isUnlinked=t,e}createDOM(t){return this.__isUnlinked?document.createElement("span"):super.createDOM(t)}updateDOM(t,e,r){return super.updateDOM(t,e,r)||t.__isUnlinked!==this.__isUnlinked}static importJSON(t){return c().updateFromJSON(t)}updateFromJSON(t){return super.updateFromJSON(t).setIsUnlinked(t.isUnlinked||!1)}static importDOM(){return null}exportJSON(){return{...super.exportJSON(),isUnlinked:this.__isUnlinked}}insertNewAfter(t,r=!0){const n=this.getParentOrThrow().insertNewAfter(t,r);if(e.$isElementNode(n)){const t=c(this.__url,{isUnlinked:this.__isUnlinked,rel:this.__rel,target:this.__target,title:this.__title});return n.append(t),t}return null}}function c(t="",r){return e.$applyNodeReplacement(new a(t,r))}function _(t){return t instanceof a}const h=e.createCommand("TOGGLE_LINK_COMMAND");function g(t,r){if("element"===t.type){const i=t.getNode();e.$isElementNode(i)||n(252);return i.getChildren()[t.offset+r]||null}return null}function d(r,n={}){const{target:i,title:l}=n,s=void 0===n.rel?"noreferrer":n.rel,a=e.$getSelection();if(!e.$isRangeSelection(a))return;const c=a.extract();if(null===r)return void c.forEach((e=>{const r=t.$findMatchingParent(e,(t=>!_(t)&&u(t)));if(r){const t=r.getChildren();for(let e=0;e<t.length;e++)r.insertBefore(t[e]);r.remove()}}));const h=new Set,d=t=>{h.has(t.getKey())||(h.add(t.getKey()),t.setURL(r),void 0!==i&&t.setTarget(i),void 0!==s&&t.setRel(s),void 0!==l&&t.setTitle(l))};if(1===c.length){const t=p(c[0],u);if(null!==t)return d(t)}!function(t){const r=e.$getSelection();if(!e.$isRangeSelection(r))return t();const n=e.$normalizeSelection__EXPERIMENTAL(r),i=n.isBackward(),l=g(n.anchor,i?-1:0),s=g(n.focus,i?0:-1),o=t();if(l||s){const t=e.$getSelection();if(e.$isRangeSelection(t)){const r=t.clone();if(l){const t=l.getParent();t&&r.anchor.set(t.getKey(),l.getIndexWithinParent()+(i?1:0),"element")}if(s){const t=s.getParent();t&&r.focus.set(t.getKey(),s.getIndexWithinParent()+(i?0:1),"element")}e.$setSelection(e.$normalizeSelection__EXPERIMENTAL(r))}}}((()=>{let t=null;for(const n of c){if(!n.isAttached())continue;const a=p(n,u);if(a){d(a);continue}if(e.$isElementNode(n)){if(!n.isInline())continue;if(u(n)){if(!(_(n)||null!==t&&t.getParentOrThrow().isParentOf(n))){d(n),t=n;continue}for(const t of n.getChildren())n.insertBefore(t);n.remove();continue}}const c=n.getPreviousSibling();u(c)&&c.is(t)?c.append(n):(t=o(r,{rel:s,target:i,title:l}),n.insertAfter(t),t.append(n))}}))}const f=d;function p(t,e){let r=t;for(;null!==r&&null!==r.getParent()&&!e(r);)r=r.getParentOrThrow();return e(r)?r:null}exports.$createAutoLinkNode=c,exports.$createLinkNode=o,exports.$isAutoLinkNode=_,exports.$isLinkNode=u,exports.$toggleLink=d,exports.AutoLinkNode=a,exports.LinkNode=l,exports.TOGGLE_LINK_COMMAND=h,exports.toggleLink=f;
