/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

import{addClassNamesToElement as t,isHTMLAnchorElement as e,$findMatchingParent as r}from"@lexical/utils";import{createCommand as n,ElementNode as i,$isRangeSelection as l,$applyNodeReplacement as s,$isElementNode as u,$getSelection as o,$normalizeSelection__EXPERIMENTAL as a,$setSelection as _}from"lexical";function c(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var h=c((function(t){const e=new URLSearchParams;e.append("code",t);for(let t=1;t<arguments.length;t++)e.append("v",arguments[t]);throw Error(`Minified Lexical error #${t}; visit https://lexical.dev/docs/error?${e} for the full message or use the non-minified dev environment for full errors and additional helpful warnings.`)}));const g=new Set(["http:","https:","mailto:","sms:","tel:"]);class f extends i{static getType(){return"link"}static clone(t){return new f(t.__url,{rel:t.__rel,target:t.__target,title:t.__title},t.__key)}constructor(t="",e={},r){super(r);const{target:n=null,rel:i=null,title:l=null}=e;this.__url=t,this.__target=n,this.__rel=i,this.__title=l}createDOM(e){const r=document.createElement("a");return r.href=this.sanitizeUrl(this.__url),null!==this.__target&&(r.target=this.__target),null!==this.__rel&&(r.rel=this.__rel),null!==this.__title&&(r.title=this.__title),t(r,e.theme.link),r}updateDOM(t,r,n){if(e(r)){const e=this.__url,n=this.__target,i=this.__rel,l=this.__title;e!==t.__url&&(r.href=e),n!==t.__target&&(n?r.target=n:r.removeAttribute("target")),i!==t.__rel&&(i?r.rel=i:r.removeAttribute("rel")),l!==t.__title&&(l?r.title=l:r.removeAttribute("title"))}return!1}static importDOM(){return{a:t=>({conversion:d,priority:1})}}static importJSON(t){return p().updateFromJSON(t)}updateFromJSON(t){return super.updateFromJSON(t).setURL(t.url).setRel(t.rel||null).setTarget(t.target||null).setTitle(t.title||null)}sanitizeUrl(t){try{const e=new URL(t);if(!g.has(e.protocol))return"about:blank"}catch(e){return t}return t}exportJSON(){return{...super.exportJSON(),rel:this.getRel(),target:this.getTarget(),title:this.getTitle(),url:this.getURL()}}getURL(){return this.getLatest().__url}setURL(t){const e=this.getWritable();return e.__url=t,e}getTarget(){return this.getLatest().__target}setTarget(t){const e=this.getWritable();return e.__target=t,e}getRel(){return this.getLatest().__rel}setRel(t){const e=this.getWritable();return e.__rel=t,e}getTitle(){return this.getLatest().__title}setTitle(t){const e=this.getWritable();return e.__title=t,e}insertNewAfter(t,e=!0){const r=p(this.__url,{rel:this.__rel,target:this.__target,title:this.__title});return this.insertAfter(r,e),r}canInsertTextBefore(){return!1}canInsertTextAfter(){return!1}canBeEmpty(){return!1}isInline(){return!0}extractWithChild(t,e,r){if(!l(e))return!1;const n=e.anchor.getNode(),i=e.focus.getNode();return this.isParentOf(n)&&this.isParentOf(i)&&e.getTextContent().length>0}isEmailURI(){return this.__url.startsWith("mailto:")}isWebSiteURI(){return this.__url.startsWith("https://")||this.__url.startsWith("http://")}}function d(t){let r=null;if(e(t)){const e=t.textContent;(null!==e&&""!==e||t.children.length>0)&&(r=p(t.getAttribute("href")||"",{rel:t.getAttribute("rel"),target:t.getAttribute("target"),title:t.getAttribute("title")}))}return{node:r}}function p(t="",e){return s(new f(t,e))}function m(t){return t instanceof f}class O extends f{constructor(t="",e={},r){super(t,e,r),this.__isUnlinked=void 0!==e.isUnlinked&&null!==e.isUnlinked&&e.isUnlinked}static getType(){return"autolink"}static clone(t){return new O(t.__url,{isUnlinked:t.__isUnlinked,rel:t.__rel,target:t.__target,title:t.__title},t.__key)}getIsUnlinked(){return this.__isUnlinked}setIsUnlinked(t){const e=this.getWritable();return e.__isUnlinked=t,e}createDOM(t){return this.__isUnlinked?document.createElement("span"):super.createDOM(t)}updateDOM(t,e,r){return super.updateDOM(t,e,r)||t.__isUnlinked!==this.__isUnlinked}static importJSON(t){return U().updateFromJSON(t)}updateFromJSON(t){return super.updateFromJSON(t).setIsUnlinked(t.isUnlinked||!1)}static importDOM(){return null}exportJSON(){return{...super.exportJSON(),isUnlinked:this.__isUnlinked}}insertNewAfter(t,e=!0){const r=this.getParentOrThrow().insertNewAfter(t,e);if(u(r)){const t=U(this.__url,{isUnlinked:this.__isUnlinked,rel:this.__rel,target:this.__target,title:this.__title});return r.append(t),t}return null}}function U(t="",e){return s(new O(t,e))}function k(t){return t instanceof O}const N=n("TOGGLE_LINK_COMMAND");function v(t,e){if("element"===t.type){const r=t.getNode();u(r)||h(252);return r.getChildren()[t.offset+e]||null}return null}function x(t,e={}){const{target:n,title:i}=e,s=void 0===e.rel?"noreferrer":e.rel,c=o();if(!l(c))return;const h=c.extract();if(null===t)return void h.forEach((t=>{const e=r(t,(t=>!k(t)&&m(t)));if(e){const t=e.getChildren();for(let r=0;r<t.length;r++)e.insertBefore(t[r]);e.remove()}}));const g=new Set,f=e=>{g.has(e.getKey())||(g.add(e.getKey()),e.setURL(t),void 0!==n&&e.setTarget(n),void 0!==s&&e.setRel(s),void 0!==i&&e.setTitle(i))};if(1===h.length){const t=w(h[0],m);if(null!==t)return f(t)}!function(t){const e=o();if(!l(e))return t();const r=a(e),n=r.isBackward(),i=v(r.anchor,n?-1:0),s=v(r.focus,n?0:-1),u=t();if(i||s){const t=o();if(l(t)){const e=t.clone();if(i){const t=i.getParent();t&&e.anchor.set(t.getKey(),i.getIndexWithinParent()+(n?1:0),"element")}if(s){const t=s.getParent();t&&e.focus.set(t.getKey(),s.getIndexWithinParent()+(n?0:1),"element")}_(a(e))}}}((()=>{let e=null;for(const r of h){if(!r.isAttached())continue;const l=w(r,m);if(l){f(l);continue}if(u(r)){if(!r.isInline())continue;if(m(r)){if(!(k(r)||null!==e&&e.getParentOrThrow().isParentOf(r))){f(r),e=r;continue}for(const t of r.getChildren())r.insertBefore(t);r.remove();continue}}const o=r.getPreviousSibling();m(o)&&o.is(e)?o.append(r):(e=p(t,{rel:s,target:n,title:i}),r.insertAfter(e),e.append(r))}}))}const T=x;function w(t,e){let r=t;for(;null!==r&&null!==r.getParent()&&!e(r);)r=r.getParentOrThrow();return e(r)?r:null}export{U as $createAutoLinkNode,p as $createLinkNode,k as $isAutoLinkNode,m as $isLinkNode,x as $toggleLink,O as AutoLinkNode,f as LinkNode,N as TOGGLE_LINK_COMMAND,T as toggleLink};
